window.Gleam.initSearch([{"doc":"htmgrrrl","title":"htmgrrrl","content":"# htmgrrrl\n\n[![Package Version](https://img.shields.io/hexpm/v/htmgrrrl)](https://hex.pm/packages/htmgrrrl)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/htmgrrrl/)\n\nGleam bindings to [htmerl](https://github.com/zadean/htmerl), the fast and\nmemory efficient Erlang HTML SAX parser.\n\n```gleam\nimport htmgrrrl.{Characters}\n\npub fn main() {\n  let take_text = fn(state, _line, event) {\n    case event {\n      Characters(text) -&gt; [text, ..state]\n      _ -&gt; state\n    }\n  }\n\n  &quot;&lt;p&gt;Hello, Joe!&lt;/p&gt;&lt;p&gt;Hello, Mike!&lt;/p&gt;&quot;\n  |&gt; htmgrrrl.sax([], take_text)\n  // =&gt; Ok([&quot;Hello, Mike!&quot;, &quot;Hello, Joe!&quot;])\n}\n```\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add htmgrrrl\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/htmgrrrl&gt;.\n\n## What&#39;s with the name?\n\nIt&#39;s a Gleam-y play on &quot;htmerl&quot; that makes a nod to [Riot Grrrl](https://en.wikipedia.org/wiki/Riot_grrrl).\n","url":"index.html"},{"doc":"htmgrrrl","title":"Attribute","content":"pub type Attribute {\n  Attribute(\n    uri: String,\n    prefix: String,\n    name: String,\n    value: String,\n  )\n}\n\nAttribute(\n  uri: String,\n  prefix: String,\n  name: String,\n  value: String,\n)\n\n\nSynonyms:\nhtmgrrrl.Attribute\nhtmgrrrl Attribute","url":"htmgrrrl.html#Attribute"},{"doc":"htmgrrrl","title":"SaxEvent","content":"pub type SaxEvent {\n  StartDocument\n  EndDocument\n  StartPrefixMapping(prefix: String, uri: String)\n  EndPrefixMapping(prefix: String)\n  StartElement(\n    uri: String,\n    local_name: String,\n    qualified_name: #(String, String),\n    attributes: List(Attribute),\n  )\n  EndElement(\n    uri: String,\n    local_name: String,\n    qualified_name: #(String, String),\n  )\n  Characters(String)\n  IgnorableWhitespace(String)\n  ProcessingInstruction(target: String, data: String)\n  Comment(String)\n  StartCdata\n  EndCdata\n  StartDtd(name: String, public_id: String, system_id: String)\n  EndDtd\n  ElementDecl(name: String, model: String)\n  AttributeDeclaration(\n    element_name: String,\n    attribute_name: String,\n    type_: String,\n    mode: String,\n    value: String,\n  )\n  InternalEntityDeclaration(name: String, value: String)\n  ExternalEntityDeclaration(\n    name: String,\n    public_id: String,\n    system_id: String,\n  )\n  UnparsedEntityDeclaration(\n    name: String,\n    public_id: String,\n    system_id: String,\n    notation_name: String,\n  )\n  NotationDeclaration(\n    name: String,\n    public_id: String,\n    system_id: String,\n  )\n}\n SAX events that can be emitted by the parser.\n\n These are based off of the events found in Erlang&#39;s `xmerl_sax_parser`.\n\nStartDocument\n Receive notification of the beginning of a document. The SAX parser will\n send this event only once before any other event callbacks. \n\nEndDocument\n Receive notification of the end of a document. The SAX parser will send\n this event only once, and it will be the last event during the parse. \n\nStartPrefixMapping(prefix: String, uri: String)\n Begin the scope of a prefix-URI Namespace mapping. Note that\n start/endPrefixMapping events are not guaranteed to be properly nested\n relative to each other: all startPrefixMapping events will occur\n immediately before the corresponding startElement event, and all\n endPrefixMapping events will occur immediately after the corresponding\n endElement event, but their order is not otherwise guaranteed. There will\n not be start/endPrefixMapping events for the &quot;xml&quot; prefix, since it is\n predeclared and immutable.\n\nEndPrefixMapping(prefix: String)\n End the scope of a prefix-URI mapping.\n\nStartElement(\n  uri: String,\n  local_name: String,\n  qualified_name: #(String, String),\n  attributes: List(Attribute),\n)\n Receive notification of the beginning of an element. The Parser will send\n this event at the beginning of every element in the XML document; there\n will be a corresponding endElement event for every startElement event\n (even when the element is empty). All of the element&#39;s content will be\n reported, in order, before the corresponding endElement event.\n\nEndElement(\n  uri: String,\n  local_name: String,\n  qualified_name: #(String, String),\n)\n Receive notification of the end of an element. The SAX parser will send\n this event at the end of every element in the XML document; there will be\n a corresponding startElement event for every endElement event (even when\n the element is empty).\n\nCharacters(String)\n Receive notification of character data. \n\nIgnorableWhitespace(String)\n Receive notification of ignorable whitespace in element content.\n\nProcessingInstruction(target: String, data: String)\n Receive notification of a processing instruction. The Parser will send\n this event once for each processing instruction found: note that\n processing instructions may occur before or after the main document\n element.\n\nComment(String)\n Report an XML comment anywhere in the document (both inside and outside of\n the document element). \n\nStartCdata\n Report the start of a CDATA section. The contents of the CDATA section\n will be reported through the regular characters event. \n\nEndCdata\n Report the end of a CDATA section. \n\nStartDtd(name: String, public_id: String, system_id: String)\n Report the start of DTD declarations, it&#39;s reporting the start of the\n DOCTYPE declaration. If the document has no DOCTYPE declaration, this\n event will not be sent.\n\nEndDtd\n Report the end of DTD declarations, it&#39;s reporting the end of the DOCTYPE\n declaration. \n\nElementDecl(name: String, model: String)\n Report an element type declaration. The content model will consist of the\n string &quot;EMPTY&quot;, the string &quot;ANY&quot;, or a parenthesised group, optionally\n followed by an occurrence indicator. The model will be normalized so that\n all parameter entities are fully resolved and all whitespace is\n removed,and will include the enclosing parentheses. Other normalization\n (such as removing redundant parentheses or simplifying occurrence\n indicators) is at the discretion of the parser.\n\nAttributeDeclaration(\n  element_name: String,\n  attribute_name: String,\n  type_: String,\n  mode: String,\n  value: String,\n)\n Report an attribute type declaration.\n\nInternalEntityDeclaration(name: String, value: String)\n Report an internal entity declaration.\n\nExternalEntityDeclaration(\n  name: String,\n  public_id: String,\n  system_id: String,\n)\n Report a parsed external entity declaration.\n\nUnparsedEntityDeclaration(\n  name: String,\n  public_id: String,\n  system_id: String,\n  notation_name: String,\n)\n Receive notification of an unparsed entity declaration event.\n\nNotationDeclaration(\n  name: String,\n  public_id: String,\n  system_id: String,\n)\n Receive notification of a notation declaration event.\n\nSynonyms:\nhtmgrrrl.SaxEvent\nhtmgrrrl SaxEvent","url":"htmgrrrl.html#SaxEvent"},{"doc":"htmgrrrl","title":"sax","content":"pub fn sax(\n  a: String,\n  b: a,\n  c: fn(a, Int, SaxEvent) -&gt; a,\n) -&gt; Result(a, Nil)\n Iterate over a stream of SAX events, calling the given function for each\n event.\n\n The given function takes the current state, the line number of the event,\n and the event itself, and returns the new state. The final state is\n returned.\n\nSynonyms:\nhtmgrrrl.sax\nhtmgrrrl sax","url":"htmgrrrl.html#sax"},{"doc":"htmgrrrl","title":"htmgrrrl","content":"","url":"htmgrrrl.html"}]);